package de.bioinf.appl;

import de.bioinf.utils.BioinfException;

public interface ApplComponent {
	/**
	 * Every (registered) component saves its component values (automatically at
	 * the end/termination of the program) using this method. To register a
	 * component just call ApplBase.add(ApplComponent).
	 * 
	 * @see ApplBase.stop()
	 */
	public void prepareParams() throws BioinfException;

	/**
	 * Returns the id of this component
	 */
	public String getCompId();
}
