package de.bioinf.appl;

import java.awt.BorderLayout;
import java.net.MalformedURLException;
import java.net.URL;

import javax.swing.JApplet;
import javax.swing.JComponent;

import de.bioinf.utils.BioinfException;
import de.bioinf.utils.Www;

/**
 * The base class for applets here!
 * 
 * @author ng
 */
public abstract class Applet extends JApplet {
	private JComponent mask = null;

	/**
	 * The base class for applets.
	 */
	public Applet() {
		super();
		Environment.init();
	}

	/**
	 * Displays a page in a separate browser window. The page may be specified without the leading "http://hostpath/"
	 * part, that means just as an absolute path to the page like "/path/to/page".
	 */
	protected void display(String page) throws BioinfException {
		if (page != null) {
			try {
				URL url = null;
				try {
					url = new URL(page);
				} catch (MalformedURLException e) {
					url = new URL(Www.URL_BASE + page);
				}
				getAppletContext().showDocument(url, "_blank");
			} catch (Exception e) {
				throw BioinfException.convert(e).addMessage(String.format("Cannot display page %s", page));
			}
		}
	}

	/**
	 * Sets the mask
	 */
	protected void setMask(JComponent comp) {
		if (mask != null) {
			getContentPane().remove(mask);
		}
		getContentPane().add(mask = comp, BorderLayout.CENTER);
		validate();
		repaint();
	}
}
