package de.bioinf.appl;

import java.awt.Color;
import java.awt.Font;
import java.awt.Insets;
import java.util.Enumeration;

import javax.swing.UIManager;
import javax.swing.plaf.ColorUIResource;
import javax.swing.plaf.FontUIResource;

/**
 * The environment for applications and applets.
 * 
 * @author ng
 */
public class Environment {
	/**
	 * The default font for all components
	 */
	public static final Font DEFAULT_FONT = new Font("Verdana", Font.PLAIN, 12);
	public static final Font SMALL_FONT = new Font("Verdana", Font.PLAIN, 10);

	/**
	 * Initializes the UIManger settings
	 */
	public static void init() {
		Enumeration<Object> keys = UIManager.getDefaults().keys();
		while (keys.hasMoreElements()) {
			Object key = keys.nextElement();
			Object value = UIManager.get(key);
			String skey = key instanceof String ? (String) key : "";

			if (value instanceof ColorUIResource && skey.indexOf("selectionBackground") >= 0) {
				UIManager.put(key, Colors.SELECTED_BG);
			}
			// Font
			else if (value instanceof FontUIResource) {
				UIManager.put(key, DEFAULT_FONT);
			}
		}

		UIManager.put("TabbedPane.contentAreaColor", Colors.DEFAULT_BG);
		UIManager.put("TabbedPane.contentBorderInsets", new Insets(1, 1, 1, 1));
		UIManager.put("TabbedPane.selected", Colors.SELECTED_BG);
		UIManager.put("TabbedPane.tabAreaInsets", new Insets(0, 0, 0, 0));

		UIManager.put("Button.background", new Color(224, 224, 224));
		UIManager.put("CheckBox.background", Colors.DEFAULT_BG);
		UIManager.put("CheckBoxMenuItem.background", Colors.DEFAULT_BG);
		UIManager.put("ComboBox.background", new Color(224, 224, 224));
		UIManager.put("EditorPane.background", Colors.DEFAULT_BG);
		UIManager.put("OptionPane.background", Colors.DEFAULT_BG);
		UIManager.put("Panel.background", Colors.DEFAULT_BG);
		UIManager.put("ScrollPane.background", Colors.DEFAULT_BG);
		UIManager.put("TabbedPane.background", Colors.DEFAULT_BG);
		UIManager.put("TextArea.background", new Color(248, 248, 240));
		UIManager.put("TextField.background", new Color(248, 248, 240));
		UIManager.put("TextPane.background", Colors.DEFAULT_BG);
		UIManager.put("ToggleButton.background", Colors.DEFAULT_BG);

		/*
		 * UIManager.put("MenuBar.background", new Color(0x60, 0xa0, 0x60)); UIManager.put("MenuBar.foreground",
		 * Color.WHITE); UIManager.put("MenuBar.selectionBackground", Colors.SELECTED_BG);
		 * UIManager.put("MenuBar.selectionForeground", Color.BLACK);
		 * 
		 * UIManager.put("Menu.background", new Color(0x60, 0xa0, 0x60)); UIManager.put("Menu.foreground", Color.WHITE);
		 * UIManager.put("Menu.selectionBackground", Colors.SELECTED_BG); UIManager.put("Menu.selectionForeground",
		 * Color.BLACK);
		 * 
		 * UIManager.put("MenuItem.background", new Color(0x60, 0xa0, 0x60)); UIManager.put("MenuItem.foreground",
		 * Color.WHITE); UIManager.put("MenuItem.selectionBackground", Colors.SELECTED_BG);
		 * UIManager.put("MenuItem.selectionForeground", Color.BLACK); UIManager.put("MenuItem.border", new Borders(1,
		 * 2, 1, 2));
		 */

		UIManager.put("ScrollBar.width", 12);
		UIManager.put("ScrollBar.height", 12);
	}
}
