package de.bioinf.ui;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Insets;

import javax.swing.border.Border;

/**
 * Class implementing the Border interface
 * 
 * @author ng
 */
public class Borders implements Border {
	private Insets insets = null;

	/**
	 * Create Borders with no border around.
	 */
	public Borders() {
		this(0, 0, 0, 0);
	}

	public Borders(int size) {
		this(size, size, size, size);
	}

	public Borders(int top, int left, int bottom, int right) {
		super();
		insets = new Insets(top, left, bottom, right);
	}

	public Insets getBorderInsets(Component c) {
		return insets;
	}

	public boolean isBorderOpaque() {
		return false;
	}

	public void paintBorder(Component c, Graphics g, int x, int y, int width, int height) {
		g.translate(x, y);
		Color color = g.getColor();
		g.setColor(c.getBackground());
		g.fillRect(0, 0, insets.left, height);
		g.fillRect(insets.left, 0, width - (insets.left + insets.right), insets.top);
		g.fillRect(width - insets.right, 0, insets.right, height);
		g.fillRect(insets.left, height - insets.bottom, width - (insets.left + insets.right), insets.bottom);
		g.setColor(color);
		g.translate(-x, -y);
	}
}
