package de.bioinf.ui;

import java.awt.event.ActionEvent;

/**
 * A dialog to change a colormap. The given colormap on the constructors will remain and changed.
 * 
 * @author ng
 */
public class ColorMapDialog extends InputDialog<ColorMapPanel> {
	public ColorMapDialog(String title, ColorMap colormap) {
		this(title, colormap, 400, 400);
	}

	public ColorMapDialog(String title, ColorMap colormap, int with, int height) {
		super(title, new ColorMapPanel(colormap), with, height);
	}

	public void init(ColorMap colormap) {
		getInputComponent().init(colormap);
	}

	@Override
	public void afterOk(ActionEvent e) {
	}

	@Override
	public void setVisible(boolean state) {
		if (state) {
			getInputComponent().refresh();
		}
		super.setVisible(state);
	}
}
