package de.bioinf.ui;

import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.ArrayList;

import javax.swing.JComboBox;

import de.bioinf.utils.SelectionEvent;
import de.bioinf.utils.SelectionListener;

/**
 * A special combo box
 * 
 * @author ng
 */
public class ComboBox extends JComboBox implements ItemListener, InputComponent {
	private ArrayList<SelectionListener<ComboBox>> listeners = new ArrayList<SelectionListener<ComboBox>>();
	private int savedIndex = 0;

	public ComboBox(Object[] elems) {
		super(elems);
		addItemListener(this);
		saveState();
	}

	public void addSelectionListener(SelectionListener<ComboBox> listener) {
		listeners.add(listener);
	}

	public void itemStateChanged(ItemEvent e) {
		if (e.getStateChange() == ItemEvent.SELECTED) {
			for (SelectionListener<ComboBox> listener : listeners) {
				listener.selected(new SelectionEvent<ComboBox>(this));
			}
		}
	}

	@Override
	public void reset() {
		setSelectedIndex(savedIndex);
	}

	@Override
	public void saveState() {
		savedIndex = getSelectedIndex();
	}

	@Override
	public boolean isOk() {
		return true;
	}
}
