package de.bioinf.ui;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

/**
 * A dialog for displaying help. This dialog can be "reused", that means to create only one instance and reuse it using
 * the setContent() method to display different help message/pages.
 * 
 * @author ng
 */
public class HelpDialog extends JDialog {
	private JComponent g_comp = null;

	class OkListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			HelpDialog.this.setVisible(false);
		}
	}

	public HelpDialog(String title) {
		this(title, 700, 400);
	}

	/**
	 * Creates a dialog of width and height with the title.
	 */
	public HelpDialog(String title, int width, int height) {
		super();

		setTitle(title);
		setSize(width, height);
		setLayout(new BorderLayout());

		JButton ok = new JButton("Ok");
		add(BorderLayout.SOUTH, ok);

		ok.addActionListener(new OkListener());
	}

	public void setContent(JComponent comp) {
		if (g_comp != null) {
			remove(g_comp);
		}
		add(g_comp = comp, BorderLayout.CENTER);
		setVisible(true);
	}

	public void setContent(String text) {
		setContent(new JScrollPane(new JTextArea(text)));
	}
}
