package de.bioinf.ui;

import java.awt.BorderLayout;

import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.SwingConstants;
import javax.swing.border.EtchedBorder;

import de.bioinf.appl.Colors;

/**
 * A panel providing default layout for sections. A section consists of a header and one additional element that is
 * placed in the center of the section.
 * 
 * @author ng
 */
public class SectionPanel extends JPanel {
	private class Header extends Label {
		private Header(String title) {
			super(title);
			setBackground(Colors.LABEL_BG);
			setHorizontalAlignment(SwingConstants.CENTER);
		}
	}

	public SectionPanel(String title) {
		super(new BorderLayout());
		setBorder(new EtchedBorder());
		add(new Header(title), BorderLayout.NORTH);
	}

	public SectionPanel(String title, JComponent comp) {
		this(title);
		addSectionComponent(comp);
	}

	public void addSectionComponent(JComponent comp) {
		add(comp, BorderLayout.CENTER);
	}
}
