package de.bioinf.ui;

import javax.swing.JTextField;

/**
 * A component that may be used e.g. in InputDialogs
 * 
 * @author ng
 */
public class TextField extends JTextField implements InputComponent {
	private String savedValue = null;

	public TextField() {
		super();
		saveState();
	}

	public TextField(String value) {
		super(value);
		saveState();
	}

	public boolean isOk() {
		return true;
	}

	public void reset() {
		setText(savedValue);
	}

	public void saveState() {
		savedValue = getText();
	}
}
