package de.bioinf.ui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTextField;

import de.bioinf.appl.Appl;
import de.bioinf.appl.ApplComponent;
import de.bioinf.appl.ApplParam;
import de.bioinf.utils.BioinfException;
import de.bioinf.utils.MessageEvent;
import de.bioinf.utils.MessageListener;

/**
 * Every visual application should have (at last) one window.
 * 
 * @author ng
 */
public abstract class Window extends JFrame implements ApplComponent, MessageListener {
	private JTextField g_message = null;

	static final String PARAM_SIZE = ".size";

	public Window(String title, MenuBar menubar, JComponent dataArea) throws BioinfException {
		super("Iob - " + title);

		setSize(ApplParam.get(getCompId() + PARAM_SIZE, Appl.cnfparams, new Dimension(1000, 600)));
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent ev) {
				Appl.stop();
			}
		});

		g_message = new TextField();
		g_message.setEditable(false);
		g_message.setBackground(Color.WHITE);
		g_message.setForeground(Color.RED);

		setJMenuBar(menubar);
		JPanel base = new JPanel(new BorderLayout());
		base.add(dataArea, BorderLayout.CENTER);
		base.add(g_message, BorderLayout.SOUTH);
		setContentPane(base);

		setVisible(true);
		Appl.add(this);
	}

	public void prepareParams() throws BioinfException {
		ApplParam.set(getCompId() + PARAM_SIZE, Appl.cnfparams, getSize());
	}

	public void notice(MessageEvent event) {
		g_message.setText(event.getMessage());
	}
}
