package de.bioinf.ui.graph;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Polygon;

import de.bioinf.utils.BioinfException;

public class FilledPolygonElem extends PolygonElem {
	private Polygon polygon = null;

	public FilledPolygonElem(CoordPanel panel, PolygonValuePair[] values, String id) throws BioinfException {
		super(panel, values, id);
	}

	@Override
	public boolean isHit(int x, int y) {
		return polygon.contains(x, y);
	}

	@Override
	public void paint(Graphics g) {
		polygon = toPolygon();
		g.setColor(getBackground());
		g.fillPolygon(polygon);
		g.setColor(Color.BLACK);
		g.drawPolygon(polygon);
	}

	protected Polygon toPolygon() {
		PolygonValuePair[] values = getValues();
		int[] xs = new int[values.length];
		int[] ys = new int[values.length];
		for (int i = 0; i < values.length; i++) {
			xs[i] = getPanel().getX(values[i].xval);
			ys[i] = getPanel().getY(values[i].yval);
		}
		return new Polygon(xs, ys, xs.length - 1);
	}

}
