package de.bioinf.ui.graph;

import java.awt.Graphics;
import java.awt.Image;

public class ImageCoordElem extends CoordElem {
	private Image img = null;
	private int width = 0;
	private int height = 0;

	public ImageCoordElem(CoordPanel panel, double xval, double yval, int width, int height, Image img, String id) {
		super(panel, xval, yval, id);
		this.width = width;
		this.height = height;
		this.img = img;
	}

	public void paint(Graphics g) {
		g.setColor(getBackground());
		g.drawImage(img, getX() - (width / 2), getY() - (height / 2), width, height, null);
	}

	public boolean isHit(int x, int y) {
		return Math.abs(getX() - x) <= (width / 2) && Math.abs(getY() - y) <= (height / 2);
	}
}
