package de.bioinf.utils;

import java.awt.Component;

/**
 * A special thread class mainly used in applets to act on clicking button and start a special task.
 * 
 * @author ng
 */
public abstract class Executor extends Thread {
	/**
	 * The component that will be disabled through execution.
	 */
	private Component comp;

	/**
	 * Execute the task
	 */
	public abstract void execute() throws BioinfException;

	public Executor() {
		this(null);
	}

	public Executor(Component comp) {
		super();
		this.comp = comp;
	}

	public void run() {
		if (comp != null) {
			comp.setEnabled(false);
		}
		try {
			execute();
		} catch (Exception e) {
			Logger.error(e);
		}
		if (comp != null) {
			comp.setEnabled(true);
		}
	}
}
