package de.bioinf.utils;

/**
 * A thread that writes every specified seconds to Logger.info()
 */
public abstract class ProgressThread extends Thread {
	private boolean doit = true;
	private int sleep = 0;

	public ProgressThread(int seconds) {
		this.sleep = seconds * 1000;
	}

	/**
	 * The message to be written
	 */
	public abstract String getMessage();

	public void run() {
		try {
			while (doit) {
				sleep(sleep);
				if (doit) {
					Logger.info(getMessage());
				}
			}
		} catch (Exception e) {
		}
	}

	// stop() is already used and final!
	public void terminate() {
		doit = false;
	}
}
