package de.bioinf.utils;

/**
 * A selector to check header lines of fasta sequences. It is possible to read
 * sequences and discard special ones. It is also possible to throw an exception
 * and terminate a sequence reading.
 * 
 * @author ng
 */
public interface SequenceSelector {
	/**
	 * Returns true or false to either get or skip a read sequence. If an
	 * exception is thrown the reading process will terminate and a message will
	 * be send by exception.
	 */
	public boolean isOk(String header) throws BioinfException;
}
