package de.bioinf.utils;

/**
 * A class for making hash searches faster.
 * 
 * @author ng
 */
public class StringKey {
	private String value = null;
	private int hashCode = 0;

	public StringKey(String value) {
		this.value = value;
		this.hashCode = value.hashCode();
	}

	@Override
	public int hashCode() {
		return hashCode;
	}

	@Override
	public boolean equals(Object o) {
		if (o == null || !(o instanceof StringKey)) {
			return false;
		}
		StringKey key = (StringKey) o;
		return hashCode == key.hashCode || value.equals(key.value);
	}
}
